#ifndef __capturedesktop2_inc__

// WARNING!! external file: finder.ico

#ifndef __windows_inc__
#include "windows.inc"
#endif
#ifndef __commctrl_inc__
#include "commctrl.inc" // for temporary window required by direct input
#endif
#ifndef __vfw_inc__
#include "vfw.inc"      // video capture
#endif
#ifndef __dinput_inc__
#include "dinput.inc"   // mouse capture
#endif


// [1] Left mouse button sets CDesktopCapture.m_clicked to true. This change is detected in
// CDesktopCapture::WriteFrame to draw a circle in captured video.
//
// [2] Pressing the "wheel button" sets CDesktopCapture.m_break to true. Change is detected in
// main() and avi write loop quits
//
// [3] Pressing WIN+1 breaks the loop too
//
// The video will be not longer than 5 minutes, unless you change <NumFrames> in main()
#define CAPTURE_MOUSE // define this to use [1] and [2]




// codec settings:
// XVID MPEG4: Single Pass; Quantizer:4; Profile:unrestricted; QualityPreset:realtime
//
// 

class CDesktopCapture
{
public:
	// [constructor][destructor]
	declare CDesktopCapture();
	declare _CDesktopCapture();

	// [create and close output avi file]
	declare CreateVideoFile(TCHAR *path, int width, int height, int fps),BOOL;
	declare CloseVideoFile();

	// [compressor]
	declare ChooseCompresor(HWND hwndParent),BOOL; // calls SetCompressor
	declare LoadCompressorOptions(string *path),BOOL; // calls SetCompressor
	declare SaveCompressorOptions(string *path),BOOL;
	// advanced
	declare SetCompressor(AVICOMPRESSOPTIONS *opts),BOOL; // <opts> can be NULL to only cleanup m_CompressorOptions

	// collecting video frames
	declare WriteFrame(int left,int top,int width,int height),BOOL;

	// background threads
#ifdef CAPTURE_MOUSE
	declare MouseProc();
#endif
	int         m_firstvariable[0];

	DWORD       m_BltFlags;       // SRCCOPY | CAPTUREBLT will include tooltips and layered windows
	BOOL        m_fCaptureCursor; // set to true/false
	HICON       m_hClickIcon;

	HRESULT     m_hr;             // latest COM status
	IAVIFile   *m_avifile;
	IAVIStream *m_pstream;
	IAVIStream *m_compressor;

	HDC         m_dcDesktop;      // [video source] desktop device context
	HDC         m_cdc;            // [video destination] compatible device context for memory DIB bitmap
	int         m_frameno;        // current video frame index; auto increment

	HBITMAP     m_dib;            // handle to DIB bitmap
	HBITMAP     m_dcbmp;          // handle to original bitmap from compatible device context
	int         m_biSizeImage;    // number of bytes in DIB bitmap
	void       *m_pBits;          // pointer to DIB pixels

	BITMAPINFOHEADER m_bihdr;     // DIB and input video stream format

	AVICOMPRESSOPTIONS m_CompressorOptions;
	AVISTREAMINFOW     m_vidstrhdr;

	//{ capture mouse clicks
#ifdef CAPTURE_MOUSE
	HANDLE      m_mouseevent;
	HANDLE      m_hMouseThread;
	BOOL        m_clicked;
	BOOL        m_break;
#endif
	//}
	int         m_lastvariable[0];
}



#endif
